
/*
 * Copyright (C) Nginx, Inc.
 * Copyright (C) Valentin V. Bartenev
 */


#ifndef _NGX_THREAD_POOL_H_INCLUDED_
#define _NGX_THREAD_POOL_H_INCLUDED_

//TODO, add in Nginx conf
#define AIO_LOADBALANCE 1
#define DLB2  1
#define QUEUE_NUM 1

#include <ngx_config.h>
#include <ngx_core.h>
#include <ngx_event.h>
#include "dlb.h"


struct ngx_thread_task_s {
    ngx_thread_task_t   *next;
    ngx_uint_t           id;
    void                *ctx;
    void               (*handler)(void *data, ngx_log_t *log);
    ngx_event_t          event;
    u_char              priority;
};

typedef struct {
    int dev_id;
    dlb_hdl_t dlb;
    int domain_id;
    dlb_domain_hdl_t domain;
    dlb_dev_cap_t cap;
    dlb_resources_t rsrcs;
    int ldb_pool_id;
    int dir_pool_id;
    int queue_id[QUEUE_NUM];
    int num_credit_combined;
    int num_credit_ldb;
    int num_credit_dir;
    dlb_port_hdl_t  tx_port;
    dlb_port_hdl_t  rx_port[32];    //TODO, rx port number
} ngx_ldb_t;

typedef struct ngx_thread_pool_s  ngx_thread_pool_t;


ngx_thread_pool_t *ngx_thread_pool_add(ngx_conf_t *cf, ngx_str_t *name);
ngx_thread_pool_t *ngx_thread_pool_get(ngx_cycle_t *cycle, ngx_str_t *name);

ngx_thread_task_t *ngx_thread_task_alloc(ngx_pool_t *pool, size_t size);
ngx_int_t ngx_thread_task_post(ngx_thread_pool_t *tp, ngx_thread_task_t *task);


#endif /* _NGX_THREAD_POOL_H_INCLUDED_ */
